﻿package logica{
	import flash.display.MovieClip;
	
	public class Cursor extends MovieClip {
		import flash.events.*;
		
		public static const CURSOR_AVISAR:String = "cursorAvisar";	
		private var xfinal:int;
		private var longuitud:int;
		private var vCursor:Number;
		private var cursor:MovieClip = new MovieClip();
		private var inicioX:int;
		private var controlador:Controlador;
		private var contador=0;
		private var repeticiones:int;
		private var demoactiva:Boolean;
		private var avisarEnX:int=-1;
		
		public function Cursor(num:int,f:int,rep:int,vel:Number):void {
		
			longuitud=num;
			xfinal=f;
			demoactiva=false;
			repeticiones=rep;
			vCursor=vel;
			controlador=Controlador.getControlador();
			inicioX=200+controlador.getCentradoCancion();
			formarlinea();
			
		}
		
		
		private function cursoravanza(e:Event) {
			cursor.x+=vCursor;
			 if(((getPosRelativa()==avisarEnX) || (getPosRelativa()==avisarEnX+1)||(getPosRelativa()==avisarEnX+2)) && avisarEnX!=-1){
					 		dispatchEvent(new Event(CURSOR_AVISAR));
					 
				 }

			if (cursor.x > xfinal) {
				 contador++;
				 cursor.x=inicioX;
				 
				 
				 if ((contador==repeticiones) && (!demoactiva)) {
					 
						cursor.removeEventListener(Event.ENTER_FRAME,cursoravanza);
						ControladorVista.getControladorVista().siguienteCancion();
				 }
			    if ((contador==repeticiones) && demoactiva) {
						parar();
						reiniciarCursor();
				 }
				 
			    if ((contador!=repeticiones) && demoactiva) {
					 ControladorVista.getControladorVista().repetirDemo();

				 }
 
			}
		}
		
		private function formarlinea() {
			var comp:int;
			var ycomp=50;
			var xcomp=0;
			
			
			for (comp = 0;comp<longuitud;comp++)
			{
				var linea:Linea=new Linea();
				linea.name="componente"+comp.toString();
				linea.x=xcomp;linea.y=ycomp;ycomp+=110;
				cursor.addChild(linea);

			}

			
		}
			
		public function reiniciarCursor(){
			cursor.x=inicioX-160;
			contador=0;
			demoactiva=false;
			}
		public function empezar(){
			reiniciarCursor();
			cursor.addEventListener(Event.ENTER_FRAME,cursoravanza);

			}
		public function parar(){
			cursor.removeEventListener(Event.ENTER_FRAME,cursoravanza);

			}
		public function demo(){
			cursor.x=inicioX;
			cursor.addEventListener(Event.ENTER_FRAME,cursoravanza);
			demoactiva=true;
		}

		
		public function getCursorMC():MovieClip{
			return cursor;
			}
			
		public function getPosRelativa():int{//posición relativa respecto a las partituras
			return (cursor.x-inicioX);
			}
	   public function setAvisarEnX(posx:int){
		   avisarEnX=posx;
		   

	   }

	}
}


