﻿package logica{

	import flash.display.MovieClip;



	public class Estado extends MovieClip {

		var trianguloactivo:Boolean;
		var clavesactiva:Boolean;
		var panderoactivo:Boolean;
		var crotalosactivo:Boolean;
		var cajaactiva:Boolean;
		var charlesactivo:Boolean;
		var platoactivo:Boolean;
		var bomboactivo:Boolean;
		var cancionElegida:String;

		var juegoactivo:Boolean;


		var numTimbresMusicalesPermitidos:int;
		var nivelActual:int;
		var nivel1Superado:Boolean;
		var nivel2Superado:Boolean;
		var nivel3Superado:Boolean;
		var nivel4Superado:Boolean;
		
		var copas:Array =new Array (false,false,false);




		public function getEstadoInstr(instr:String):Boolean {
			var ret:Boolean;

			switch (instr) {

				case "triangulo" :
					ret=trianguloactivo;
					break;
				case "claves" :
					ret=clavesactiva;
					break;
				case "pandero" :
					ret=panderoactivo;
					break;
				case "crotalos" :
					ret=crotalosactivo;
					break;
				case "caja" :
					ret=cajaactiva;
					break;
				case "charles" :
					ret=charlesactivo;
					break;
				case "plato" :
					ret=platoactivo;
					break;
				case "bombo" :
					ret=bomboactivo;
					break;
				default :
					break;

			}
			return ret;


		}
		public function getEstadoTimbresPermitidos():int {
			return numTimbresMusicalesPermitidos;


		}

		public function getNivelActual():int {
			return nivelActual;


		}

		public function getNivelSuperado(nv:int):Boolean {
			var ret:Boolean;

			switch (nv) {

				case 1 :
					ret=nivel1Superado;
					break;
				case 2 :
					ret=nivel2Superado;
					break;
				case 3 :
					ret=nivel3Superado;
					break;
				case 4 :
					ret=nivel4Superado;
					break;
				default :
					break;

			}

			return ret;


		}		
		public function getEstadoCopa(nv:int):Boolean {


			return copas[nv-1];


		}
		
		public function setCopaActual() {
			copas[getNivelActual()-1]=true;


		}
		public function getCancionElegida():String {
			return cancionElegida;


		}
		public function setCancionElegida(cad:String) {
			cancionElegida=cad;


		}
		public function getEstadoJuego():Boolean {
			return juegoactivo;


		}
		public function setEstadoJuego(b:Boolean) {
			juegoactivo=b;


		}
		public function setEstadoInstr(instr:String,b:Boolean) {
			switch (instr) {

				case "triangulo" :
					trianguloactivo=b;
					break;
				case "claves" :
					clavesactiva=b;
					break;
				case "pandero" :
					panderoactivo=b;
					break;
				case "crotalos" :
					crotalosactivo=b;
					break;
				case "caja" :
					cajaactiva=b;
					break;
				case "charles" :
					charlesactivo=b;
					break;
				case "plato" :
					platoactivo=b;
					break;
				case "bombo" :
					bomboactivo=b;
					break;
				default :
					break;

			}

		}

		public function setEstadoTimbresPermitidos(i:int) {
			numTimbresMusicalesPermitidos=i;


		}
		public function setNivelActual(i:int) {
			nivelActual=i;


		}
		public function setNivelSuperado(nv:int,b:Boolean) {

			switch (nv) {

				case 1 :
					nivel1Superado=b;
					break;
				case 2 :
					nivel2Superado=b;
					break;
				case 3 :
					nivel3Superado=b;
					break;
				case 4 :
					nivel4Superado=b;
					break;
				default :
					break;

			}

		}
		public function numTimbresMusicales():int {
			var salida=0;
			if (panderoactivo) {
				salida++;
			}
			if (clavesactiva) {
				salida++;
			}
			if (trianguloactivo) {
				salida++;
			}
			if (crotalosactivo) {
				salida++;
			}
			if (cajaactiva) {
				salida++;
			}
			if (platoactivo) {
				salida++;
			}
			if (charlesactivo) {
				salida++;
			}
			if (bomboactivo) {
				salida++;
			}
			return salida;
		}
		public function reiniciarEstadoInstrumentos() {
			trianguloactivo=false;
			clavesactiva=false;
			panderoactivo=false;
			crotalosactivo=false;
			cajaactiva=false;
			charlesactivo=false;
			platoactivo=false;
			bomboactivo=false;
		}
	}
}