﻿package {

	import flash.display.MovieClip;
	import flash.display.SimpleButton;
	import flash.display.DisplayObject;
	import flash.ui.Keyboard;
	import flash.events.*;
	import flash.text.TextField;
	import flash.media.*;
	import flash.geom.ColorTransform;
	import flash.utils.Timer;
	import flash.media.SoundMixer;
	import logica.Academia;
	import logica.Juego;

	public class ControladorVista extends MovieClip {


		private static  var singleton:ControladorVista;

		import logica.Controlador;

		var c:Controlador;

		var contenedorInstrumentos:MovieClip;
		var contenedorCancion:MovieClip;
		var contenedorCursor:MovieClip;
		private var centradoCancion:int=20;

		public function ControladorVista() {
			singleton=this;
			c=Controlador.getControlador();
		}
		public static function getControladorVista():ControladorVista {
			if (singleton==null) {
				singleton=new ControladorVista();
			}

			return singleton;

		}
		public function menuNiveles() {
			var s:Sound = new sonidonivel();
			var sc:SoundChannel = new SoundChannel();
			sc = s.play();
			sc.addEventListener(Event.SOUND_COMPLETE, callarJuego);

			btnnivel1.addEventListener(MouseEvent.MOUSE_DOWN, nivel1);
			btnnivel2.addEventListener(MouseEvent.MOUSE_DOWN, nivel2);
			btnnivel3.addEventListener(MouseEvent.MOUSE_DOWN, nivel3);
			btnnivel4.addEventListener(MouseEvent.MOUSE_DOWN, nivel4);


			estrellaNivel1.visible=estrellaNivel2.visible=estrellaNivel3.visible=false;
			estrellaNivel4.visible=false;
			if (c.getNivelSuperado(1)) {
				estrellaNivel1.visible=true;

			}
			if (c.getNivelSuperado(2)) {
				estrellaNivel2.visible=true;

			}
			if (c.getNivelSuperado(3)) {
				estrellaNivel3.visible=true;

			}
			if (c.getNivelSuperado(4)) {
				estrellaNivel4.visible=true;

			}
		}
		public function menuInstrumentos() {
			var s:Sound;
			var sc:SoundChannel = new SoundChannel();

			percusitoJuego.stop();
			if (!c.checkJuego()) {//Academia
				var nv:int=c.checkNivelActual();
				if (nv<3) {
					s=new sonidouninstrum();

				} else {
					s=new sonidodosinstrum();
				}
				sc = s.play();
				percusitoJuego.play();
				sc.addEventListener(Event.SOUND_COMPLETE, callarJuego);
				btnvolver.addEventListener(MouseEvent.MOUSE_DOWN,atrasN);
				seguirmenu.addEventListener(MouseEvent.MOUSE_DOWN, continuar);


			} else {//Juego
				s=new sonidouninstrum();
				sc = s.play();
				percusitoJuego.play();
				btnvolver.addEventListener(MouseEvent.MOUSE_DOWN,atrasElegir);
				seguirmenu.addEventListener(MouseEvent.MOUSE_DOWN, continuarJuego);
			}

			seguirmenu.visible=false;
			invisibilizarTextosMenu();


			contenedorElegirInstr.crotalos.addEventListener(MouseEvent.MOUSE_DOWN, elegir);
			contenedorElegirInstr.triangulo.addEventListener(MouseEvent.MOUSE_DOWN, elegir);
			contenedorElegirInstr.claves.addEventListener(MouseEvent.MOUSE_DOWN, elegir);
			contenedorElegirInstr.pandero.addEventListener(MouseEvent.MOUSE_DOWN, elegir);
			contenedorElegirInstr.caja.addEventListener(MouseEvent.MOUSE_DOWN, elegir);
			contenedorElegirInstr.bombo.addEventListener(MouseEvent.MOUSE_DOWN, elegir);
			contenedorElegirInstr.plato.addEventListener(MouseEvent.MOUSE_DOWN, elegir);
			contenedorElegirInstr.charles.addEventListener(MouseEvent.MOUSE_DOWN, elegir);



		}
		public function escenaInicio() {

			var s:Sound = new sonidointro();
			var sc:SoundChannel = new SoundChannel();
			sc = s.play();
			sc.addEventListener(Event.SOUND_COMPLETE, introCompletada);
			btnSkip1.addEventListener(MouseEvent.MOUSE_DOWN, saltar);
		}
		public function escenaMenuPrincipal() {

			btnAcademia1.addEventListener(MouseEvent.MOUSE_DOWN, entrarAcademia);
			percusitoMenu.stop();


		}
		public function escenaAcademia1() {


			var academia:Academia=new Academia();
			academia.name="Academia";
			addChild(academia);
			academia.empezarPrueba1();

		}
		public function finAcademia1() {

			gotoAndStop(1,"EscenaNiveles");


		}


		public function escenaAcademia() {
			var nv=c.checkNivelActual();
			var academia:Academia=new Academia();
			academia.name="Academia";
			var s:Sound = new sonidoacademiajuego();
			var sc:SoundChannel = new SoundChannel();
			sc = s.play();
			hablarJuego();
			sc.addEventListener(Event.SOUND_COMPLETE, callarJuego);

			reiniciarEstrellas();

			addChild(academia);
			switch (nv) {

				case 1 :
					academia.empezarNivel1();
					break;

				case 2 :
					academia.empezarNivel2();
					break;

				case 3 :
					academia.empezarNivel3();
					break;

				case 4 :
					academia.empezarNivel4();
					break;
				default :
					trace("Fallo en niveles");
					break;
			}
			btnescuchar.addEventListener(MouseEvent.MOUSE_DOWN, escuchar);
			btntocar.addEventListener(MouseEvent.MOUSE_DOWN, tocar);
			btnrapido.addEventListener(MouseEvent.MOUSE_DOWN, masRapido);
			btnlento.addEventListener(MouseEvent.MOUSE_DOWN, masLento);
			txtfps.text=framerate().toString();
			contenedorInstrumentos=new MovieClip();
			inicializarinstrumentos();
			addChild(contenedorInstrumentos);


		}
		public function escenaMenuCanciones() {
			var s:Sound = new sonidocancionnivel();
			var sc:SoundChannel = new SoundChannel();
			sc = s.play();

			percusitoJuego.play();
			sc.addEventListener(Event.SOUND_COMPLETE, callarJuego);
			c.setCancion("");
			muñeca1.visible=vaca1.visible=burro1.visible=gallina1.visible=false;
			copa1.visible=copa2.visible=copa3.visible=false;
			if (c.getEstadoCopa(1)) {
				copa1.visible=true;
			}
			if (c.getEstadoCopa(2)) {
				copa2.visible=true;
			}
			if (c.getEstadoCopa(3)) {
				copa3.visible=true;
			}
			muñeca.addEventListener(MouseEvent.MOUSE_DOWN, elegirCancion);
			burro.addEventListener(MouseEvent.MOUSE_DOWN, elegirCancion);
			vaca.addEventListener(MouseEvent.MOUSE_DOWN, elegirCancion);
			gallina.addEventListener(MouseEvent.MOUSE_DOWN, elegirCancion);
			nv1.addEventListener(MouseEvent.MOUSE_DOWN, elegirNivel);
			nv2.addEventListener(MouseEvent.MOUSE_DOWN, elegirNivel);
			nv3.addEventListener(MouseEvent.MOUSE_DOWN, elegirNivel);

		}
		public function escenaJuego() {
			var j:Juego=new Juego();
			j.name="Juego";
			addChild(j);

			btnatras.addEventListener(MouseEvent.MOUSE_DOWN, atrasJuego);
			btnescuchar.addEventListener(MouseEvent.MOUSE_DOWN, escucharJuego);
			btntocar.addEventListener(MouseEvent.MOUSE_DOWN, tocarJuego);
			j.inicializar(c.getCancion());

			contenedorInstrumentos=new MovieClip();
			inicializarinstrumentos();
			addChild(contenedorInstrumentos);



		}
		public function escenaPuntuacion() {
			btnsiguiente.addEventListener(MouseEvent.MOUSE_DOWN, siguienteElegir);
			btnsiguiente.visible=false;
			var j:Juego=Juego(getChildByName("Juego"));
			j.mostrarPuntuacion();

		}
		private function elegirCancion(e:Event) {
			muñeca1.visible=vaca1.visible=burro1.visible=gallina1.visible=false;
			this[e.target.name+"1"].visible=true;

			c.setCancion(e.target.name);
			c.setNumInstrumentosCancion(1);

		}
		private function elegirNivel(e:Event) {
			var nv:int;
			switch (e.target.name) {

				case "nv1" :
					nv=1;
					break;

				case "nv2" :
					nv=2;
					break;

				case "nv3" :
					nv=3;
					break;
				default :
					break;

			}
			c.setNivelActual(nv);
			if (c.getCancion()=="") {
				var s:Sound = new sonidocancionolvido();
				var sc:SoundChannel = new SoundChannel();
				sc = s.play();

				percusitoJuego.play();
				sc.addEventListener(Event.SOUND_COMPLETE, callarJuego);
				trace("No hay canción elegida");
			} else {
				SoundMixer.stopAll();
				gotoAndStop(1,"EscenaInstrumentos");
			}
		}
		public function reiniciarEstrellas() {

			e1.alpha=e2.alpha=e3.alpha=e4.alpha=e5.alpha=0.2;

		}
		private function hablarJuego() {
			percusitoJuego.play();

		}
		private function callarJuego(e:Event) {
			percusitoJuego.stop();

		}
		public function framerate():int {

			return stage.frameRate;


		}



		public function añadirCancionyCursor(cancion:MovieClip,cursor:MovieClip) {
			contenedorCursor=cursor;
			contenedorCancion=cancion;
			contenedorCursor.x=getCentradoCancion();
			contenedorCancion.x=centradoCancion;
			addChild(contenedorCancion);
			addChild(contenedorCursor);


		}
		public function siguienteCancion() {

			if (!c.checkJuego()) {//Academia
				var a:Academia=Academia(getChildByName("Academia"));

				btnescuchar.visible=true;
				if (!a.cancionSuperada()) {
					trace("cancion no superada");
					var s:Sound = new sonidoacademiaintentadenuevo();
					var sc:SoundChannel = new SoundChannel();
					sc = s.play();
					percusitoJuego.play();
					sc.addEventListener(Event.SOUND_COMPLETE, a.callarJuego);


				} else {
					removeChild(contenedorCancion);
					removeChild(contenedorCursor);

					if (!a.siguienteCancion()) {
						removeChild(contenedorInstrumentos);


						c.setNivelSuperado();



					}
				}
			} else {//Juego

				var j:Juego=Juego(getChildByName("Juego"));
				removeChild(contenedorCancion);
				removeChild(contenedorCursor);
				removeChild(contenedorInstrumentos);
				c.reiniciarIntrumentos();
				gotoAndStop(1,"EscenaPuntuacion");

			}
		}
		public function repetirDemo() {
			var j:Juego=Juego(getChildByName("Juego"));
			j.repetirDemo();



		}



		private function inicializarinstrumentos():void {
			var posicionInicial=new Array(600,450,350,250);
			var xcomp;
			var ycomp=764;

			xcomp=posicionInicial[c.checkNumTimbresMusicales()-1];


			if (c.checkInstr("triangulo")) {
				añadirtriangulo(xcomp,ycomp);
				xcomp+=300;
			}
			if (c.checkInstr("claves")) {
				añadirclaves(xcomp,ycomp);
				xcomp+=250;
			}
			if (c.checkInstr("pandero")) {
				añadirpandero(xcomp,ycomp);
				xcomp+=250;
			}
			if (c.checkInstr("crotalos")) {
				añadircrotalos(xcomp,ycomp);
				xcomp+=200;
			}
			if (c.checkInstr("plato")) {
				añadirplato(xcomp,ycomp);
				xcomp+=300;
			}
			if (c.checkInstr("bombo")) {
				añadirbombo(xcomp,ycomp);
				xcomp+=300;
			}
			if (c.checkInstr("caja")) {
				añadircaja(xcomp,ycomp);
				xcomp+=300;
			}
			if (c.checkInstr("charles")) {
				añadircharles(xcomp,ycomp);
				xcomp+=300;
			}
		}


		public function añadirclaves(xclaves:int,yclaves:int):void {
			var claves:btnclaves=new btnclaves();
			claves.name="claves";
			claves.x=xclaves;
			claves.y=yclaves;
			claves.addEventListener(MouseEvent.MOUSE_DOWN, pulsa);
			contenedorInstrumentos.addChild(claves);


		}
		public function añadirpandero(xpandero:int,ypandero:int):void {
			var pandero:btnpandero=new btnpandero();
			pandero.name="pandero";
			pandero.x=xpandero;
			pandero.y=ypandero;
			pandero.addEventListener(MouseEvent.MOUSE_DOWN, pulsa);
			contenedorInstrumentos.addChild(pandero);


		}
		public function añadirtriangulo(xtriangulo:int,ytriangulo:int):void {
			var triangulo:btntriangulo=new btntriangulo();
			triangulo.name="triangulo";
			triangulo.x=xtriangulo;
			triangulo.y=ytriangulo;
			triangulo.addEventListener(MouseEvent.MOUSE_DOWN, pulsa);
			contenedorInstrumentos.addChild(triangulo);


		}
		public function añadircrotalos(xcrotalos:int,ycrotalos:int):void {
			var crotalos:btncrotalos=new btncrotalos();
			crotalos.name="crotalos";
			crotalos.x=xcrotalos;
			crotalos.y=ycrotalos;
			crotalos.addEventListener(MouseEvent.MOUSE_DOWN, pulsa);
			contenedorInstrumentos.addChild(crotalos);


		}
		public function añadircaja(xcaja:int,ycaja:int):void {
			var caja:btncaja=new btncaja();
			caja.name="caja";
			caja.x=xcaja;
			caja.y=ycaja;
			caja.addEventListener(MouseEvent.MOUSE_DOWN, pulsa);
			contenedorInstrumentos.addChild(caja);


		}
		public function añadirbombo(xbombo:int,ybombo:int):void {
			var bombo:btnbombo=new btnbombo();
			bombo.name="bombo";
			bombo.x=xbombo;
			bombo.y=ybombo;
			bombo.addEventListener(MouseEvent.MOUSE_DOWN, pulsa);
			contenedorInstrumentos.addChild(bombo);


		}
		public function añadirplato(xplato:int,yplato:int):void {
			var plato:btnplato=new btnplato();
			plato.name="plato";
			plato.x=xplato;
			plato.y=yplato;
			plato.addEventListener(MouseEvent.MOUSE_DOWN, pulsa);
			contenedorInstrumentos.addChild(plato);


		}
		public function añadircharles(xcharles:int,ycharles:int):void {
			var charles:btncharles=new btncharles();
			charles.name="charles";
			charles.x=xcharles;
			charles.y=ycharles;
			charles.addEventListener(MouseEvent.MOUSE_DOWN, pulsa);
			contenedorInstrumentos.addChild(charles);


		}
		public function cambiarTxtNumeroTimbresPerm(cad:String) {
			txtNumTimbresPerm.text=cad;


		}
		public function cambiarSeguirMenu(b:Boolean) {
			seguirmenu.visible=b;


		}
		private function invisibilizarTextosMenu() {
			txtpandero.visible=false;
			txtclaves.visible=false;
			txttriangulo.visible=false;
			txtcrotalos.visible=false;

			txtcaja.visible=false;
			txtbombo.visible=false;
			txtcharles.visible=false;
			txtplato.visible=false;
		}
		public function escucharVisible(b:Boolean) {

			btnescuchar.visible=b;

		}
		public function getCentradoCancion() {

			return centradoCancion;


		}
		//MANEJADORES DE EVENTOS DE BOTON



		private function saltar(event:MouseEvent):void {
			SoundMixer.stopAll();
			gotoAndStop(1,"EscenaAcademiaJuego");
		}
		private function introCompletada(event:Event):void {
			gotoAndStop(1,"EscenaAcademiaJuego");
		}
		private function entrarAcademia(event:MouseEvent) {

			gotoAndStop(1,"EscenaAcademia1");

		}


		private function pulsa(e:Event) {
			if (!c.checkJuego()) {
				var a:Academia=Academia(getChildByName("Academia"));
				a.instrumentoPulsado(e.target.name);
			} else {
				var j:Juego=Juego(getChildByName("Juego"));
				j.instrumentoPulsado(e.target.name);
			}
		}
		private function atrasJuego(e:Event) {
			var j:Juego=Juego(getChildByName("Juego"));
			c.reiniciarIntrumentos();
			SoundMixer.stopAll();
			removeChild(contenedorInstrumentos);
			j.reiniciar();
			removeChild(j);
			removeChild(contenedorCancion);
			removeChild(contenedorCursor);
			gotoAndStop(1,"EscenaAcademiaJuego");
		}
		private function atrasN(e:Event) {

			gotoAndStop(1,"EscenaNiveles");
		}
		private function atrasElegir(e:Event) {
			c.reiniciarIntrumentos();
			gotoAndStop(1,"EscenaElegir");
		}
		private function siguienteElegir(e:Event) {
			c.reiniciarIntrumentos();
			var j:Juego=Juego(getChildByName("Juego"));
			j.borrarEstrellas();
			removeChild(j);
			gotoAndStop(1,"EscenaElegir");
		}
		private function continuarJuego(e:Event) {
			SoundMixer.stopAll();
			gotoAndStop(1,"EscenaJuego");
		}
		//NIVELES
		private function nivel1(e:MouseEvent):void {
			c.nivel1();
			gotoAndStop(1,"EscenaInstrumentos");
		}
		private function nivel2(e:MouseEvent):void {
			c.nivel2();
			gotoAndStop(1,"EscenaInstrumentos");
		}
		private function nivel3(e:MouseEvent):void {
			c.nivel3();
			gotoAndStop(1,"EscenaInstrumentos");
		}
		private function nivel4(e:MouseEvent):void {
			c.nivel4();
			gotoAndStop(1,"EscenaInstrumentos");
		}
		//ELECCION
		private function elegir(ev:MouseEvent):void {
			var txtnombre:TextField = this["txt"+ev.target.name];
			txtnombre.visible=!txtnombre.visible;
			c.elegir(ev.target.name);

		}
		private function continuar(event:MouseEvent):void {
			gotoAndStop(1,"EscenaInterpretar");
		}
		//JUEGO

		private function masRapido(event:MouseEvent):void {
			if (framerate()<50) {

				stage.frameRate+=2;
				txtfps.text=framerate().toString();
			}
		}
		private function masLento(event:MouseEvent):void {
			if (framerate() > 20) {
				stage.frameRate-=2;
				txtfps.text=framerate().toString();

			}
		}
		private function escuchar(event:MouseEvent):void {

			var a:Academia=Academia(getChildByName("Academia"));
			a.escucharCancion();
		}
		private function tocar(event:MouseEvent):void {
			var a:Academia=Academia(getChildByName("Academia"));
			a.tocarCancion();
			btnescuchar.visible=false;
		}
		private function escucharJuego(event:MouseEvent):void {

			var j:Juego=Juego(getChildByName("Juego"));
			j.escucharCancion();
		}
		private function tocarJuego(event:MouseEvent):void {
			var j:Juego=Juego(getChildByName("Juego"));

			j.tocarCancion();
		}




	}//FIN CONTROLADOR



}//FIN PACKAGE