﻿package logica{

	import flash.display.MovieClip;
	import flash.events.*;


	public class Controlador extends MovieClip {

		import logica.Cursor;
		import logica.Cancion;
		import logica.Estado;
		import ControladorVista;


		public static  const CANCION_COMPUESTA:String = "cancionCompuesta";


		var e:Estado;

		private static  var singleton:Controlador;

		var cursor:Cursor;
		var cancion:Cancion;
		var cv:ControladorVista;



		public function Controlador() {

			cv=ControladorVista.getControladorVista();
		}
		public static function getControlador():Controlador {
			if (singleton==null) {
				singleton=new Controlador();
			}
			return singleton;

		}
		public function inicializarMenuPrincipal() {
			e.setEstadoJuego(false);
			cv.escenaMenuPrincipal();




		}
		public function inicializarAcademia1() {
			cv.escenaAcademia1();

		}

		/*public function inicializarEscenaJuego()
		{cv.escenaJuego();
		
		if (!e.getEstadoCancion()){
		cancion = new Cancion(e.numTimbresMusicales(),-1);
		
		cancion.addEventListener(CANCION_COMPUESTA, onCancionCompuesta);
		
		}else{
		cursor.reiniciarCursor();
		cancion=new Cancion(e.numTimbresMusicales(),cancion.getNumCancionElegida());
		
		
		cv.añadirCancionyCursor(cancion.getContenedorCancion(),cursor.getCursorMC());
		
		
		}
		
		      }
		 
		 */
		public function inicializarEscenaAcademia() {
			cv.escenaAcademia();

		}
		/*
		 private function onCancionCompuesta(ev:Event):void { 
		
		cursor= new Cursor(e.numTimbresMusicales(),cancion.getPosFinal()+250+200);//los 250 son por el centrado que se hace en ControladorVista
		  //y los 200 por el espacio que deja Cancion para meter los iconos.
		cv.añadirCancionyCursor(cancion.getContenedorCancion(),cursor.getCursorMC());
		
		 removeEventListener(CANCION_COMPUESTA, onCancionCompuesta);
		 
		 
		 }*/
		public function inicializarInicio() {
			e=new Estado();
			cv.escenaInicio();

		}
		public function inicializarMenuNiveles() {
			e.reiniciarEstadoInstrumentos();
			cv.menuNiveles();

		}
		public function inicializarMenuInstrumentos() {

			var cadena:String;
			cv.menuInstrumentos();

			cadena=e.getEstadoTimbresPermitidos().toString();


			cv.cambiarTxtNumeroTimbresPerm(cadena);

		}
		public function inicializarMenuCanciones() {

			e.setEstadoJuego(true);
			cv.escenaMenuCanciones();

		}
		public function inicializarJuego() {


			cv.escenaJuego();

		}
		
		public function inicializarPuntuacion(){
			cv.escenaPuntuacion();
			
		}
		/*public function inicializarEscenaFinal()
		 { 
		 cv.escenaFinal();
		
		 }*/
		public function getCentradoCancion() {


			return cv.getCentradoCancion();

		}
		/*public function finJuego()
		{
		cv.siguienteEscenaJuego();
		
		}*/




		public function checkInstr(instr:String):Boolean {

			return e.getEstadoInstr(instr);

		}
		public function checkJuego():Boolean {

			return e.getEstadoJuego();

		}
		public function setCancion(cad:String) {

			e.setCancionElegida(cad);

		}
		public function getCancion():String {

			return e.getCancionElegida();

		}
		public function checkNumTimbresMusicales():int {
			return e.numTimbresMusicales();


		}

		public function checkNivelActual():int {

			return e.getNivelActual();

		}
		public function setNivelActual(i:int) {

			return e.setNivelActual(i);

		}
		public function escucharVisible(b:Boolean) {
			cv.escucharVisible(b);

		}
		public function nivel1() {
			e.setEstadoTimbresPermitidos(1);
			e.setNivelActual(1);


		}
		public function nivel2() {
			e.setEstadoTimbresPermitidos(1);
			e.setNivelActual(2);
		}
		public function nivel3() {
			e.setEstadoTimbresPermitidos(2);
			e.setNivelActual(3);
		}
		public function nivel4() {
			e.setEstadoTimbresPermitidos(2);
			e.setNivelActual(4);
		}
		public function setNumInstrumentosCancion(i:int) {

			e.setEstadoTimbresPermitidos(i);




		}
		public function setNivelSuperado() {
			e.setNivelSuperado(e.getNivelActual(),true);

		}
		public function getNivelSuperado(nv:int):Boolean {
			return e.getNivelSuperado(nv);

		}
		public function getEstadoCopa(c:int):Boolean {
			return e.getEstadoCopa(c);

		}
		public function setCopa() {
			e.setCopaActual();

		}
		public function reiniciarIntrumentos():void {

			e.reiniciarEstadoInstrumentos();

		}

		/*public function escuchar():void
		{
		cancion.demo();
		cursor.unaVuelta();
		
		}
		
		
		public function tocar():void
		{
		cursor.empezar();
		
		}
		*/

		public function framerate():int {
			return cv.framerate();

		}
		public function elegir(instr:String):void {
			var estado:Boolean=e.getEstadoInstr(instr);
			e.setEstadoInstr(instr,!estado);
			actualizarSelInstrumentos();

		}
		private function actualizarSelInstrumentos():void {
			var cad:String=e.numTimbresMusicales().toString();
			trace("timbressel: ",e.numTimbresMusicales());

			if (e.numTimbresMusicales() == e.getEstadoTimbresPermitidos()) {
				cv.cambiarSeguirMenu(true);

			} else {
				cv.cambiarSeguirMenu(false);
			}

		}
		//ESCENA FINAL
		/*public function volver():void
		      {
		e.setEstadoCancion(false);
		e.reiniciarEstadoInstrumentos();
		
		}
		
		 public function repetirCancion():void
		      {
		 var i:int;
		i=e.numTimbresMusicales();
		e.setEstadoCancion(true);
		//para el caso de nivel 3, asi se mantiene el numero de instrumentos anterior
		 e.setEstadoTimbresMin(i);
		e.setEstadoTimbresMax(i);
		e.reiniciarEstadoInstrumentos();
		
		}
		
		
		 public function otraCancion():void
		      {
		 e.setEstadoCancion(false);
		
		}*/



	}//FIN CONTROLADOR




}//FIN PACKAGE